<template>
  <li
    v-for="promotion in promotions"
    :key="promotion.Id"
    class="promotion__item"
  >
    <div class="promotion__image">
      <img v-lazy="promotion.ImagePathForDisplay" alt="promotion image" />
      <div class="promotion__fund">
        <font-awesome-icon
          class="mr-4 self-center"
          icon="trophy"
        ></font-awesome-icon>
        <span>{{ promotion.Amount }} {{ auth ? currency : "" }}</span>
      </div>
    </div>
    <div class="promotion__info">
      <span class="status--tag">{{ promotion.PromoCode }}</span>
      <h3 class="promotion__title" data-cut-text="50">{{ promotion.Title }}</h3>
      <div class="promotion__duration flex">
        <div class="flex flex-col pr-4">
          <span>{{ $t("start_date") }}</span>
          <span>{{ $t("end_date") }}</span>
        </div>
        <div class="flex flex-col">
          <span class="promotion__duration__time">
            {{ promotion.StartDateForDisplay }}</span
          >
          <span class="promotion__duration__time">
            {{ promotion.EndDateForDisplay }}</span
          >
        </div>
      </div>
      <div class="promotion-stat">
        <div
          class="promotion-stat__value"
          data-cut-text="100"
          v-html="promotion.Remark"
        ></div>
        <div class="bonuses__item--buttons" style="width: 100%">
          <span 
          :id="`mobile_${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
          class="btn-primary" @click="showPromotionDetail(promotion)">{{
            $t("information")
          }}</span>
          <template v-if="promotion.PromotionTypeId === 10">
            <el-button
              v-if="validateLuckyWheelbutton(promotion)"
              class="btn-default"
              @click="onClickSpinNow"
              :id="`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t("Spin Now") }}
            </el-button>
          </template>
          <template v-else>
            <el-button
              v-if="auth && promotion.IsAbleToApply"
              class="btn-default"
              @click="onApplyPromotion(promotion)"
              :id="`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
              >{{ $t("apply") }}
            </el-button>
          </template>
        </div>
      </div>
    </div>
  </li>
  <el-dialog
    v-model="dialogVisible"
    destroy-on-close
    fullscreen
    :show-close="false"
  >
    <promotion-detail
      v-if="promotion"
      :promotion="promotion"
      :auth="auth"
      :on-click-spin-now="onClickSpinNow"
      :validateLuckyWheelbutton="validateLuckyWheelbutton"
    />
  </el-dialog>
</template>
<script setup lang="ts">
import { provide, ref, inject } from "vue";
import PromotionDetail from "./promotion-detail.client.vue";
import { store } from "@/store";
import { IPromotion, Promotion } from "@/models/promotion/promotion";
import { ID } from "~~/utils/constants";

const props = defineProps({
  promotions: {
    type: Array as PropType<Promotion[]>,
    required: true,
  },
  validateLuckyWheelbutton: {
    type: Boolean,
    required: true,
  },
  onClickSpinNow: {
    type: Function,
    required: true,
  },
});
const { auth, currency } = store.state;
const promotion = ref<Promotion>({} as Promotion);
const dialogVisible = ref(false);
provide("dialogVisible", dialogVisible);
const showPromotionDetail = (promo: Promotion) => {
  promotion.value = promo;
  dialogVisible.value = true;
};
const onApplyPromotion = inject("onApplyPromotion") as (
  promotion: IPromotion
) => Promise<void>;
const route = useRoute();
watch(
  () => [route.params, props.promotions],
  () => {
    const firstLuckyWheel = props.promotions.find(
      (item) => item.Id === Number(route.params.id)
    );
    if (firstLuckyWheel) {
      showPromotionDetail(firstLuckyWheel);
    }
  },
  { deep: true, immediate: true }
);
</script>
<style lang="scss" scoped>
.btn-default,
.btn-primary {
  height: 40px;
  width: 100%;
  cursor: pointer;
}
:deep(.btn-default span){
  pointer-events: none;
}
</style>
